---
title: Create ServiceNow template
description: Datadog, the leading service for cloud-scale monitoring.
breadcrumbs: Docs > API Reference > ServiceNow Integration
---

# Create ServiceNow template{% #create-servicenow-template %}
Copy pageCopied
{% tab title="v2" %}

| Datadog site      | API endpoint                                                             |
| ----------------- | ------------------------------------------------------------------------ |
| ap1.datadoghq.com | POST https://api.ap1.datadoghq.com/api/v2/integration/servicenow/handles |
| ap2.datadoghq.com | POST https://api.ap2.datadoghq.com/api/v2/integration/servicenow/handles |
| app.datadoghq.eu  | POST https://api.datadoghq.eu/api/v2/integration/servicenow/handles      |
| app.ddog-gov.com  | POST https://api.ddog-gov.com/api/v2/integration/servicenow/handles      |
| us2.ddog-gov.com  | POST https://api.us2.ddog-gov.com/api/v2/integration/servicenow/handles  |
| app.datadoghq.com | POST https://api.datadoghq.com/api/v2/integration/servicenow/handles     |
| us3.datadoghq.com | POST https://api.us3.datadoghq.com/api/v2/integration/servicenow/handles |
| us5.datadoghq.com | POST https://api.us5.datadoghq.com/api/v2/integration/servicenow/handles |

### Overview

Create a new ServiceNow template.

### Request

#### Body Data (required)



{% tab title="Model" %}

| Parent field         | Field                                  | Type   | Description                                                                                   |
| -------------------- | -------------------------------------- | ------ | --------------------------------------------------------------------------------------------- |
|                      | data [*required*]                 | object | Data object for creating a ServiceNow template                                                |
| data                 | attributes [*required*]           | object | Attributes for creating a ServiceNow template                                                 |
| attributes           | assignment_group_id                    | uuid   | The ID of the assignment group                                                                |
| attributes           | business_service_id                    | uuid   | The ID of the business service                                                                |
| attributes           | fields_mapping                         | object | Custom field mappings for the template                                                        |
| additionalProperties | <any-key>                              | string |
| attributes           | handle_name [*required*]          | string | The handle name of the template                                                               |
| attributes           | instance_id [*required*]          | uuid   | The ID of the ServiceNow instance                                                             |
| attributes           | servicenow_tablename [*required*] | string | The name of the destination ServiceNow table                                                  |
| attributes           | user_id                                | uuid   | The ID of the user                                                                            |
| data                 | type [*required*]                 | enum   | Type identifier for ServiceNow template resources Allowed enum values: `servicenow_templates` |

{% /tab %}

{% tab title="Example" %}

```json
{
  "data": {
    "attributes": {
      "assignment_group_id": "65b3341b-0680-47f9-a6d4-134db45c603e",
      "business_service_id": "65b3341b-0680-47f9-a6d4-134db45c603e",
      "fields_mapping": {
        "<any-key>": "string"
      },
      "handle_name": "incident-template",
      "instance_id": "65b3341b-0680-47f9-a6d4-134db45c603e",
      "servicenow_tablename": "incident",
      "user_id": "65b3341b-0680-47f9-a6d4-134db45c603e"
    },
    "type": "servicenow_templates"
  }
}
```

{% /tab %}

### Response

{% tab title="201" %}
Created
{% tab title="Model" %}
Response containing a single ServiceNow template

| Parent field         | Field                                  | Type   | Description                                                                                   |
| -------------------- | -------------------------------------- | ------ | --------------------------------------------------------------------------------------------- |
|                      | data [*required*]                 | object | Data object for a ServiceNow template                                                         |
| data                 | attributes [*required*]           | object | Attributes of a ServiceNow template                                                           |
| attributes           | assignment_group_id                    | uuid   | The ID of the assignment group                                                                |
| attributes           | business_service_id                    | uuid   | The ID of the business service                                                                |
| attributes           | fields_mapping                         | object | Custom field mappings for the template                                                        |
| additionalProperties | <any-key>                              | string |
| attributes           | handle_name [*required*]          | string | The handle name of the template                                                               |
| attributes           | instance_id [*required*]          | uuid   | The ID of the ServiceNow instance                                                             |
| attributes           | servicenow_tablename [*required*] | string | The name of the destination ServiceNow table                                                  |
| attributes           | user_id                                | uuid   | The ID of the user                                                                            |
| data                 | id [*required*]                   | uuid   | Unique identifier for the ServiceNow template                                                 |
| data                 | type [*required*]                 | enum   | Type identifier for ServiceNow template resources Allowed enum values: `servicenow_templates` |

{% /tab %}

{% tab title="Example" %}

```json
{
  "data": {
    "attributes": {
      "assignment_group_id": "65b3341b-0680-47f9-a6d4-134db45c603e",
      "business_service_id": "65b3341b-0680-47f9-a6d4-134db45c603e",
      "fields_mapping": {
        "<any-key>": "string"
      },
      "handle_name": "incident-template",
      "instance_id": "65b3341b-0680-47f9-a6d4-134db45c603e",
      "servicenow_tablename": "incident",
      "user_id": "65b3341b-0680-47f9-a6d4-134db45c603e"
    },
    "id": "65b3341b-0680-47f9-a6d4-134db45c603e",
    "type": "servicenow_templates"
  }
}
```

{% /tab %}

{% /tab %}

{% tab title="400" %}
Bad Request
{% tab title="Model" %}
API error response.

| Parent field | Field                    | Type     | Description                                                                     |
| ------------ | ------------------------ | -------- | ------------------------------------------------------------------------------- |
|              | errors [*required*] | [object] | A list of errors.                                                               |
| errors       | detail                   | string   | A human-readable explanation specific to this occurrence of the error.          |
| errors       | meta                     | object   | Non-standard meta-information about the error                                   |
| errors       | source                   | object   | References to the source of the error.                                          |
| source       | header                   | string   | A string indicating the name of a single request header which caused the error. |
| source       | parameter                | string   | A string indicating which URI query parameter caused the error.                 |
| source       | pointer                  | string   | A JSON pointer to the value in the request document that caused the error.      |
| errors       | status                   | string   | Status code of the response.                                                    |
| errors       | title                    | string   | Short human-readable summary of the error.                                      |

{% /tab %}

{% tab title="Example" %}

```json
{
  "errors": [
    {
      "detail": "Missing required attribute in body",
      "meta": {},
      "source": {
        "header": "Authorization",
        "parameter": "limit",
        "pointer": "/data/attributes/title"
      },
      "status": "400",
      "title": "Bad Request"
    }
  ]
}
```

{% /tab %}

{% /tab %}

{% tab title="429" %}
Too many requests
{% tab title="Model" %}
API error response.

| Field                    | Type     | Description       |
| ------------------------ | -------- | ----------------- |
| errors [*required*] | [string] | A list of errors. |

{% /tab %}

{% tab title="Example" %}

```json
{
  "errors": [
    "Bad Request"
  ]
}
```

{% /tab %}

{% /tab %}

### Code Example

##### 
                  \## default
# 
 \# Curl command curl -X POST "https://api.datadoghq.com/api/v2/integration/servicenow/handles" \
-H "Accept: application/json" \
-H "Content-Type: application/json" \
-H "DD-API-KEY: ${DD_API_KEY}" \
-H "DD-APPLICATION-KEY: ${DD_APP_KEY}" \
-d @- << EOF
{
  "data": {
    "attributes": {
      "assignment_group_id": "65b3341b-0680-47f9-a6d4-134db45c603e",
      "business_service_id": "65b3341b-0680-47f9-a6d4-134db45c603e",
      "fields_mapping": {
        "category": "software",
        "priority": "1"
      },
      "handle_name": "incident-template",
      "instance_id": "65b3341b-0680-47f9-a6d4-134db45c603e",
      "servicenow_tablename": "incident",
      "user_id": "65b3341b-0680-47f9-a6d4-134db45c603e"
    },
    "type": "servicenow_templates"
  }
}
EOF 
                
##### 

```python
"""
Create ServiceNow template returns "Created" response
"""

from datadog_api_client import ApiClient, Configuration
from datadog_api_client.v2.api.service_now_integration_api import ServiceNowIntegrationApi
from datadog_api_client.v2.model.service_now_template_create_request import ServiceNowTemplateCreateRequest
from datadog_api_client.v2.model.service_now_template_create_request_attributes import (
    ServiceNowTemplateCreateRequestAttributes,
)
from datadog_api_client.v2.model.service_now_template_create_request_data import ServiceNowTemplateCreateRequestData
from datadog_api_client.v2.model.service_now_template_type import ServiceNowTemplateType
from uuid import UUID

body = ServiceNowTemplateCreateRequest(
    data=ServiceNowTemplateCreateRequestData(
        attributes=ServiceNowTemplateCreateRequestAttributes(
            assignment_group_id=UUID("65b3341b-0680-47f9-a6d4-134db45c603e"),
            business_service_id=UUID("65b3341b-0680-47f9-a6d4-134db45c603e"),
            fields_mapping=dict(
                category="software",
                priority="1",
            ),
            handle_name="incident-template",
            instance_id=UUID("65b3341b-0680-47f9-a6d4-134db45c603e"),
            servicenow_tablename="incident",
            user_id=UUID("65b3341b-0680-47f9-a6d4-134db45c603e"),
        ),
        type=ServiceNowTemplateType.SERVICENOW_TEMPLATES,
    ),
)

configuration = Configuration()
with ApiClient(configuration) as api_client:
    api_instance = ServiceNowIntegrationApi(api_client)
    response = api_instance.create_service_now_template(body=body)

    print(response)
```

#### Instructions

First [install the library and its dependencies](https://docs.datadoghq.com/api/latest.md?code-lang=python) and then save the example to `example.py` and run following commands:
    DD_SITE="datadoghq.com" DD_API_KEY="<API-KEY>" DD_APP_KEY="<APP-KEY>" python3 "example.py"
##### 

```ruby
# Create ServiceNow template returns "Created" response

require "datadog_api_client"
api_instance = DatadogAPIClient::V2::ServiceNowIntegrationAPI.new

body = DatadogAPIClient::V2::ServiceNowTemplateCreateRequest.new({
  data: DatadogAPIClient::V2::ServiceNowTemplateCreateRequestData.new({
    attributes: DatadogAPIClient::V2::ServiceNowTemplateCreateRequestAttributes.new({
      assignment_group_id: "65b3341b-0680-47f9-a6d4-134db45c603e",
      business_service_id: "65b3341b-0680-47f9-a6d4-134db45c603e",
      fields_mapping: {
        category: "software", priority: "1",
      },
      handle_name: "incident-template",
      instance_id: "65b3341b-0680-47f9-a6d4-134db45c603e",
      servicenow_tablename: "incident",
      user_id: "65b3341b-0680-47f9-a6d4-134db45c603e",
    }),
    type: DatadogAPIClient::V2::ServiceNowTemplateType::SERVICENOW_TEMPLATES,
  }),
})
p api_instance.create_service_now_template(body)
```

#### Instructions

First [install the library and its dependencies](https://docs.datadoghq.com/api/latest.md?code-lang=ruby) and then save the example to `example.rb` and run following commands:
    DD_SITE="datadoghq.com" DD_API_KEY="<API-KEY>" DD_APP_KEY="<APP-KEY>" rb "example.rb"
##### 

```go
// Create ServiceNow template returns "Created" response

package main

import (
	"context"
	"encoding/json"
	"fmt"
	"os"

	"github.com/DataDog/datadog-api-client-go/v2/api/datadog"
	"github.com/DataDog/datadog-api-client-go/v2/api/datadogV2"
	"github.com/google/uuid"
)

func main() {
	body := datadogV2.ServiceNowTemplateCreateRequest{
		Data: datadogV2.ServiceNowTemplateCreateRequestData{
			Attributes: datadogV2.ServiceNowTemplateCreateRequestAttributes{
				AssignmentGroupId: datadog.PtrUUID(uuid.MustParse("65b3341b-0680-47f9-a6d4-134db45c603e")),
				BusinessServiceId: datadog.PtrUUID(uuid.MustParse("65b3341b-0680-47f9-a6d4-134db45c603e")),
				FieldsMapping: map[string]string{
					"category": "software",
					"priority": "1",
				},
				HandleName:          "incident-template",
				InstanceId:          uuid.MustParse("65b3341b-0680-47f9-a6d4-134db45c603e"),
				ServicenowTablename: "incident",
				UserId:              datadog.PtrUUID(uuid.MustParse("65b3341b-0680-47f9-a6d4-134db45c603e")),
			},
			Type: datadogV2.SERVICENOWTEMPLATETYPE_SERVICENOW_TEMPLATES,
		},
	}
	ctx := datadog.NewDefaultContext(context.Background())
	configuration := datadog.NewConfiguration()
	apiClient := datadog.NewAPIClient(configuration)
	api := datadogV2.NewServiceNowIntegrationApi(apiClient)
	resp, r, err := api.CreateServiceNowTemplate(ctx, body)

	if err != nil {
		fmt.Fprintf(os.Stderr, "Error when calling `ServiceNowIntegrationApi.CreateServiceNowTemplate`: %v\n", err)
		fmt.Fprintf(os.Stderr, "Full HTTP response: %v\n", r)
	}

	responseContent, _ := json.MarshalIndent(resp, "", "  ")
	fmt.Fprintf(os.Stdout, "Response from `ServiceNowIntegrationApi.CreateServiceNowTemplate`:\n%s\n", responseContent)
}
```

#### Instructions

First [install the library and its dependencies](https://docs.datadoghq.com/api/latest.md?code-lang=go) and then save the example to `main.go` and run following commands:
    DD_SITE="datadoghq.com" DD_API_KEY="<API-KEY>" DD_APP_KEY="<APP-KEY>" go run "main.go"
##### 

```java
// Create ServiceNow template returns "Created" response

import com.datadog.api.client.ApiClient;
import com.datadog.api.client.ApiException;
import com.datadog.api.client.v2.api.ServiceNowIntegrationApi;
import com.datadog.api.client.v2.model.ServiceNowTemplateCreateRequest;
import com.datadog.api.client.v2.model.ServiceNowTemplateCreateRequestAttributes;
import com.datadog.api.client.v2.model.ServiceNowTemplateCreateRequestData;
import com.datadog.api.client.v2.model.ServiceNowTemplateResponse;
import com.datadog.api.client.v2.model.ServiceNowTemplateType;
import java.util.Map;
import java.util.UUID;

public class Example {
  public static void main(String[] args) {
    ApiClient defaultClient = ApiClient.getDefaultApiClient();
    ServiceNowIntegrationApi apiInstance = new ServiceNowIntegrationApi(defaultClient);

    ServiceNowTemplateCreateRequest body =
        new ServiceNowTemplateCreateRequest()
            .data(
                new ServiceNowTemplateCreateRequestData()
                    .attributes(
                        new ServiceNowTemplateCreateRequestAttributes()
                            .assignmentGroupId(
                                UUID.fromString("65b3341b-0680-47f9-a6d4-134db45c603e"))
                            .businessServiceId(
                                UUID.fromString("65b3341b-0680-47f9-a6d4-134db45c603e"))
                            .fieldsMapping(
                                Map.ofEntries(
                                    Map.entry("category", "software"), Map.entry("priority", "1")))
                            .handleName("incident-template")
                            .instanceId(UUID.fromString("65b3341b-0680-47f9-a6d4-134db45c603e"))
                            .servicenowTablename("incident")
                            .userId(UUID.fromString("65b3341b-0680-47f9-a6d4-134db45c603e")))
                    .type(ServiceNowTemplateType.SERVICENOW_TEMPLATES));

    try {
      ServiceNowTemplateResponse result = apiInstance.createServiceNowTemplate(body);
      System.out.println(result);
    } catch (ApiException e) {
      System.err.println(
          "Exception when calling ServiceNowIntegrationApi#createServiceNowTemplate");
      System.err.println("Status code: " + e.getCode());
      System.err.println("Reason: " + e.getResponseBody());
      System.err.println("Response headers: " + e.getResponseHeaders());
      e.printStackTrace();
    }
  }
}
```

#### Instructions

First [install the library and its dependencies](https://docs.datadoghq.com/api/latest.md?code-lang=java) and then save the example to `Example.java` and run following commands:
    DD_SITE="datadoghq.com" DD_API_KEY="<API-KEY>" DD_APP_KEY="<APP-KEY>" java "Example.java"
##### 

```rust
// Create ServiceNow template returns "Created" response
use datadog_api_client::datadog;
use datadog_api_client::datadogV2::api_service_now_integration::ServiceNowIntegrationAPI;
use datadog_api_client::datadogV2::model::ServiceNowTemplateCreateRequest;
use datadog_api_client::datadogV2::model::ServiceNowTemplateCreateRequestAttributes;
use datadog_api_client::datadogV2::model::ServiceNowTemplateCreateRequestData;
use datadog_api_client::datadogV2::model::ServiceNowTemplateType;
use std::collections::BTreeMap;
use uuid::Uuid;

#[tokio::main]
async fn main() {
    let body = ServiceNowTemplateCreateRequest::new(ServiceNowTemplateCreateRequestData::new(
        ServiceNowTemplateCreateRequestAttributes::new(
            "incident-template".to_string(),
            Uuid::parse_str("65b3341b-0680-47f9-a6d4-134db45c603e").expect("invalid UUID"),
            "incident".to_string(),
        )
        .assignment_group_id(
            Uuid::parse_str("65b3341b-0680-47f9-a6d4-134db45c603e").expect("invalid UUID"),
        )
        .business_service_id(
            Uuid::parse_str("65b3341b-0680-47f9-a6d4-134db45c603e").expect("invalid UUID"),
        )
        .fields_mapping(BTreeMap::from([
            ("category".to_string(), "software".to_string()),
            ("priority".to_string(), "1".to_string()),
        ]))
        .user_id(Uuid::parse_str("65b3341b-0680-47f9-a6d4-134db45c603e").expect("invalid UUID")),
        ServiceNowTemplateType::SERVICENOW_TEMPLATES,
    ));
    let configuration = datadog::Configuration::new();
    let api = ServiceNowIntegrationAPI::with_config(configuration);
    let resp = api.create_service_now_template(body).await;
    if let Ok(value) = resp {
        println!("{:#?}", value);
    } else {
        println!("{:#?}", resp.unwrap_err());
    }
}
```

#### Instructions

First [install the library and its dependencies](https://docs.datadoghq.com/api/latest.md?code-lang=rust) and then save the example to `src/main.rs` and run following commands:
    DD_SITE="datadoghq.com" DD_API_KEY="<API-KEY>" DD_APP_KEY="<APP-KEY>" cargo run
##### 

```typescript
/**
 * Create ServiceNow template returns "Created" response
 */

import { client, v2 } from "@datadog/datadog-api-client";

const configuration = client.createConfiguration();
const apiInstance = new v2.ServiceNowIntegrationApi(configuration);

const params: v2.ServiceNowIntegrationApiCreateServiceNowTemplateRequest = {
  body: {
    data: {
      attributes: {
        assignmentGroupId: "65b3341b-0680-47f9-a6d4-134db45c603e",
        businessServiceId: "65b3341b-0680-47f9-a6d4-134db45c603e",
        fieldsMapping: {
          category: "software",
          priority: "1",
        },
        handleName: "incident-template",
        instanceId: "65b3341b-0680-47f9-a6d4-134db45c603e",
        servicenowTablename: "incident",
        userId: "65b3341b-0680-47f9-a6d4-134db45c603e",
      },
      type: "servicenow_templates",
    },
  },
};

apiInstance
  .createServiceNowTemplate(params)
  .then((data: v2.ServiceNowTemplateResponse) => {
    console.log(
      "API called successfully. Returned data: " + JSON.stringify(data)
    );
  })
  .catch((error: any) => console.error(error));
```

#### Instructions

First [install the library and its dependencies](https://docs.datadoghq.com/api/latest.md?code-lang=typescript) and then save the example to `example.ts` and run following commands:
    DD_SITE="datadoghq.com" DD_API_KEY="<API-KEY>" DD_APP_KEY="<APP-KEY>" tsc "example.ts"
{% /tab %}
